{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Introduction\n",
    "## Scientific Computing\n",
    "https://en.wikiversity.org/wiki/Scientific_computing\n",
    "https://www.nature.com/articles/d41586-024-00725-1"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "\n",
    "## High Performance Scientific Computing\n",
    "\n",
    "https://en.wikipedia.org/wiki/High-performance_computing?useskin=vector\n",
    "\n",
    "<div style=\"text-align: center;\">\n",
    "    <img src=\"https://www.researchgate.net/profile/Gal-Oren/publication/336577121/figure/fig4/AS:814468510515200@1571195833245/Code-Languages-Top-Feature-Comparison-in-the-Case-of-Numerical-Simulations_W640.jpg\" alt=\"Image Description\" width=\"600\">\n",
    "    <figcaption>From: \"https://www.researchgate.net/publication/336577121_BACKUS_Comprehensive_High-Performance_Research_Software_Engineering_Approach_for_Simulations_in_Supercomputing_Systems/figures?lo=1\"</figcaption>\n",
    "</div>\n",
    "\n",
    "<div style=\"text-align: center;\">\n",
    "    <img src=\"https://www.admin-magazine.com/var/ezflow_site/storage/images/media/images/compilers-f01/145423-1-eng-US/compilers-F01_reference.png\" alt=\"Image Description\" width=\"900\">\n",
    "    <figcaption>From: \"https://www.admin-magazine.com/HPC/Articles/Selecting-Compilers-for-a-Supercomputer\"</figcaption>\n",
    "</div>\n",
    "\n",
    "<div style=\"text-align: center;\">\n",
    "    <img src=\"https://media.springernature.com/full/springer-static/image/art%3A10.1038%2Fs41550-021-01342-y/MediaObjects/41550_2021_1342_Fig1_HTML.png\" alt=\"Image Description\" width=\"900\">\n",
    "    <figcaption>From: \"https://www.nature.com/articles/s41550-021-01342-y\"</figcaption>\n",
    "</div>\n",
    "\n",
    "<div style=\"text-align: center;\">\n",
    "    <img src=\"https://substackcdn.com/image/fetch/w_1456,c_limit,f_webp,q_auto:good,fl_progressive:steep/https%3A%2F%2Fbucketeer-e05bbc84-baa3-437e-9518-adb32be77984.s3.amazonaws.com%2Fpublic%2Fimages%2F7cdb4847-589f-49e9-9429-cbb623821bcb_1200x786.png\" alt=\"Image Description\" width=\"900\">\n",
    "    <figcaption>From: \"https://cpufun.substack.com/p/is-fortran-a-dead-language\"</figcaption>\n",
    "</div>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "## Resources\n",
    "- Online dev env\n",
    "- Computer Room\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "## Useful links\n",
    "- <https://computers-are-fast.github.io/>\n",
    "- <https://github.com/rigtorp/awesome-modern-cpp>\n",
    "- <https://missing.csail.mit.edu/>\n",
    "- <https://courses.cs.washington.edu/courses/cse391/23sp/>\n",
    "- <https://cvw.cac.cornell.edu/roadmaps>\n",
    "- <https://hpc-wiki.info/hpc/HPC_Wiki>\n",
    "- <https://www.reddit.com/r/cpp/comments/7kurp6/recommended_c_tools_for_linux_profiler_static/>\n",
    "- <https://github.com/algorithm-visualizer/algorithm-visualizer>\n",
    "- <https://opensource.com/article/19/10/gnu-binutils>\n",
    "- <https://www.bfilipek.com/2019/10/cppecosystem.html>\n",
    "\n",
    "## Videos recorded from classes\n",
    "\n",
    "- 2024-1s: https://www.youtube.com/playlist?list=PLxbXsIEaf05pxTKg_vBGjzjttosA64dsQ\n",
    "- 2023-I: <https://www.youtube.com/playlist?list=PLxbXsIEaf05rKMvhEhoRLHL-yJypwsJPK>\n",
    "\n",
    "## Shell/bash \n",
    "\n",
    "-   <https://swcarpentry.github.io/shell-novice/>\n",
    "-   <https://github.com/phyver/GameShell>\n",
    "-   <https://overthewire.org/wargames/bandit/>\n",
    "-   <https://web.stanford.edu/class/cs124/kwc-unix-for-poets.pdf>\n",
    "-   <https://www.linode.com/docs/guides/differences-between-grep-sed-awk/>\n",
    "-   <https://www.linode.com/docs/guides/development/bash/>\n",
    "\n",
    "## git\n",
    "\n",
    "-   <https://swcarpentry.github.io/git-novice/>\n",
    "-   <http://swcarpentry.github.io/git-novice-es>\n",
    "-   <https://ohmygit.org/>\n",
    "\n",
    "## C++\n",
    "- <https://www.learncpp.com/>\n",
    "- <https://hackingcpp.com/>\n",
    "- <https://github.com/EPCCed/archer2-cpp/tree/main/lectures>\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Computer Architecture\n",
    "See 01-intro.pdf\n",
    "\n",
    "Check: \n",
    "- Branch education, computer hardware: https://www.youtube.com/watch?v=d86ws7mQYIg&t=0s"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "## Review of C++ Programming\n",
    "- Understand the problem\n",
    "- Edit the code\n",
    "- Compile\n",
    "- Execute and return to the first step\n",
    "\n",
    "### Editing\n",
    "Any text editor, but better use an ide like:\n",
    "- Visual studio (local, online)\n",
    "-   [Codeblocks](http://www.codeblocks.org/)\n",
    "-   [Geany](https://www.geany.org/)\n",
    "-   [Clion](https://www.jetbrains.com/clion/)\n",
    "- Vscodium\n",
    "- Emacs\n",
    "\n",
    "### Compiling\n",
    "Compilation + Linking\n",
    "\n",
    "```bash\n",
    "g++ filename.cpp\n",
    "```\n",
    "If the compilation is successful, this produces a file called `a.out` on\n",
    "the current directory. You can execute it as\n",
    "```bash\n",
    "./a.out\n",
    "```\n",
    "where `./` means \\\"the current directory\\\". If you want to change the\n",
    "name of the executable, you can compile as\n",
    "```bash\n",
    "g++ filename.cpp -o executablename.x\n",
    "```\n",
    "Replace `executablename.x` with the name you want for your executable.\n",
    "\n",
    "**Example program**\n",
    "```cpp\n",
    "// Mi primer programa\n",
    "#include <iostream> \n",
    "\n",
    "int main(void) \n",
    "{\n",
    "  std::cout << \"Hola Mundo!\" << std::endl;\n",
    "  return 0;\n",
    "}\n",
    "```\n",
    "\n",
    "**Compilation stages**:\n",
    "\n",
    "- Pre-processing: This does not compile. It just executes the precompiler directives. For instance, it replaces the `iostream` header and put it into the source code\n",
    "```bash\n",
    "g++ -E helloworld.cpp\n",
    "# This instruction counts how many lines my code has now\n",
    "g++ -E helloworld.cpp | wc -l\n",
    "```\n",
    "- Compilation : Object code\n",
    "```bash\n",
    "g++ -c helloworld.cpp\n",
    "```\n",
    "\n",
    "- Linking and executable: ld, use ldd and nm\n",
    "```bash\n",
    "g++ helloworld.cpp\n",
    "```\n",
    "\n",
    "### Example: Computing the mean of a vector\n",
    "```cpp\n",
    "#include <iostream>\n",
    "#include <vector>\n",
    "#include <cmath>\n",
    "#include <cstdlib>\n",
    "#include <algorithm>\n",
    "#include <numeric>\n",
    "\n",
    "// function declaration\n",
    "void fill(std::vector<double> & xdata); // llenar el vector\n",
    "double average(const std::vector<double> & xdata); // calcular el promedio\n",
    "\n",
    "int main(int argc, char **argv)\n",
    "{\n",
    "  // read command line args\n",
    "  int N = std::atoi(argv[1]);\n",
    "\n",
    "  // declare the data struct\n",
    "  std::vector<double> data;\n",
    "  data.resize(N);\n",
    "\n",
    "  // fill the vector\n",
    "  fill(data);\n",
    "\n",
    "  // compute the mean\n",
    "  double result = average(data);\n",
    "\n",
    "  // print the result\n",
    "  std::cout.precision(15);\n",
    "  std::cout.setf(std::ios::scientific);\n",
    "  std::cout << result << \"\\n\";\n",
    "\n",
    "  return 0;\n",
    "}\n",
    "\n",
    "// function implementation\n",
    "void fill(std::vector<double> & xdata)\n",
    "{\n",
    "  std::iota(xdata.begin(), xdata.end(), 1.0); // 1.0 2.0 3.0\n",
    "}\n",
    "\n",
    "double average(const std::vector<double> & xdata)\n",
    "{\n",
    "  // forma 1\n",
    "  return std::accumulate(xdata.begin(), xdata.end(), 0.0)/xdata.size();\n",
    "  // forma 2\n",
    "  // double suma = 0.0;\n",
    "  // for (auto x : xdata) {\n",
    "  //   suma += x;\n",
    "  // }\n",
    "  // return suma/data.size();\n",
    "}\n",
    "\n",
    "```\n",
    "\n",
    "\n",
    "### Loops\n",
    "\n",
    "```cpp\n",
    "// imprima los numeros del 1 al 10 suando while\n",
    "#include <iostream> \n",
    "\n",
    "int main(void) \n",
    "{\n",
    "  int n;\n",
    "\n",
    "  n = 1;\n",
    "  while (n <= 10) {\n",
    "    std::cout << n << std::endl;\n",
    "    ++n;  \n",
    "  } \n",
    "\n",
    "  return 0;\n",
    "}\n",
    "```\n",
    "\n",
    "### Condicionales\n",
    "\n",
    "```cpp\n",
    "// verificar si un numero es par\n",
    "\n",
    "/* \n",
    "   if (condicion) {\n",
    "   instrucciones\n",
    "   }\n",
    "   else {\n",
    "   instrucciones\n",
    "   }\n",
    " */\n",
    "\n",
    "#include <iostream> \n",
    "\n",
    "int main(void) \n",
    "{\n",
    "  int num;\n",
    "\n",
    "  // solicitar el numero\n",
    "  std::cout << \"Escriba un numero entero, por favor:\" << std::endl;\n",
    "  // leer el numero\n",
    "  std::cin >> num;\n",
    "\n",
    "  // verificar que el numero es par o no\n",
    "  // imprimir\n",
    "  // si el numero es par, imprimir \"el numero es par\"\n",
    "  // si no, imprimir \"el numero es impar\"\n",
    "  if (num%2 == 0) {\n",
    "    std::cout << \"El numero es par\" << std::endl;\n",
    "  } \n",
    "  if (num%2 != 0) {\n",
    "    std::cout << \"El numero es impar\" << std::endl;\n",
    "  } \n",
    "\n",
    "  //else {\n",
    "  //cout << \"El numero es impar\" << endl;\n",
    "  //}\n",
    "\n",
    "  return 0;\n",
    "}\n",
    "```\n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": []
  }
 ],
 "metadata": {
  "language_info": {
   "name": "python"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
